<?php
require_once('config.php');
$conn = fnGetConnection();

function sendMail($to, $message) {
    $subject = 'Timesheet Auto reminder';

    $headers  = 'MIME-Version: 1.0' . "\r\n";
    $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
    $headers .= 'From: Timesheet<timesheet.ds@dvara.com>' . "\r\n";
    // $headers .= 'Cc: Ashwin<ashwin.ms@dvara.com>' . "\r\n";
    mail($to, $subject, $message, $headers);
}


$sql = "select * from timesheet.employees where login_type = 'employee' and status = 'active' and reminder = 1";
$employeeQry = $conn->query($sql) or die('cannot write'. $conn->error);
while($employee = $employeeQry->fetch_assoc()){
    $employeeID = $employee['id'];
    $employeeName = $employee['name'];
    $toMail = $employee['email'];
    if(is_null($toMail)) {
	continue;
	}

    $sql = "SELECT 
    DATE_FORMAT(selected_date, '%d %b %Y') as date,
    IFNULL(hours, 0) as filled_hours,
    (8 - IFNULL(hours, 0)) as remaining_hours
    FROM
    (
        select * from
        (select adddate(DATE_SUB(CURDATE(), INTERVAL 60 DAY),t4.i*10000 + t3.i*1000 + t2.i*100 + t1.i*10 + t0.i) selected_date from
        (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t0,
        (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t1,
        (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t2,
        (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t3,
        (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t4) v
        where selected_date between DATE_SUB(CURDATE(), INTERVAL 360 DAY) and CURDATE()  AND DAYOFWEEK(selected_date) <> 1 AND DAYOFWEEK(selected_date)<>7
    ) c
    LEFT JOIN 
    (
        SELECT
        e.id,
        e.name,
        t.entry_date,
        SUM(t.entry_hours) as `hours`
        FROM timesheet.timeentry t
        INNER JOIN timesheet.employees e ON e.id = t.employee_id AND login_type = 'employee' and status = 'active'
        WHERE
        e.id = ".$employeeID."
        GROUP BY t.entry_date order by t.entry_date
    ) m
    ON c.selected_date = entry_date
    WHERE hours is null or hours < 8 order by selected_date asc";

    $entryQry = $conn->query($sql) or die('cannot write'. $conn->error);
    if($entryQry->num_rows > 0) {
        $message = '
        <html>
        <head>
        <title>timesheet Updation</title>
        </head>
        <style>
        th, td {
            padding: 10px;
            text-align: left;
        }
        th {
            background-color: #E7E9EB;
        }
        </style>
        <body>
        <p>Hi '.$employeeName.', <br><br> This is a gentle reminder to update your efforts in the time sheet portal as on date. It is noted that your efforts are not updated for the below dates. Please reach out to Sachin Nagarmath/Ashwin for any project mapping.</p>
        <table border="1" cellpadding="5" cellspacing="0">
            <tr>
                <th>Date</th><th>Hours Completed</th><th>Hours Remaining</th>
            </tr>';
        
        while($entry = $entryQry->fetch_assoc()){
            $message .= "
            <tr>
                <td>".$entry['date']."</td><td>".$entry['filled_hours']."</td><td>".$entry['remaining_hours']."</td>
            </tr>";
        }

        $message .= "
        </table>
        <p><br><hr><i>This is an automated email. Please do not reply to it.</i></p>
        </body>
        </html>";
        sendMail($toMail, $message);
    }
}
